/*
 *	Global Definitions
 */

/* This version purports to drive a PostScript device (slowly) */

typedef int BOOLEAN;
#define NEW(A) ((A *) malloc(sizeof(A)))
#define DEBUG   1		/* for massive printing of input */
				/* trace information; select by -d */
				/* option after filename: */
				/* dviview filename -d */
  
#define BINARYOPEN fopen	/* byte-oriented host version */
  
#define  TRUE             1
#define  FALSE            0
#define  FIRSTFNTCHAR     0
#define  LASTFNTCHAR    255
#define  NFNTCHARS      256
  
#define  MAXOPEN         12	/* limit on number of open PXL files */
  
#define  RESOLUTION     300
#define  STRSIZE        257
#define  NONEXISTANT     -1	/* offset for PXL files not found */
#define  NO_FILE        (FILE *)-1
#define  NONFONT	-1
#define  NONCHAR	-1
#define  DUMMYCHAR	0
  
#define	fix(x)		(int)((x) + 0.5)
  
/*
 *	Font Data Structures
 */
  
/* font type */
#define	FT_PK		1
#define	FT_PXL		2
#define	FT_LW		3
#define	FT_LWTEX	4
  
struct char_entry {		/* character entry */
  unsigned short width, height;	/* width and height in pixels */
  short xOffset, yOffset;	/* x offset and y offset in pixels */
  short psfont, pschar;
  unsigned short nbpl;		/* # of bytes per pixel data line */
  union {
    int fileOffset;
    char *pixptr;
  } where;
  int tfmw;			/* TFM width */
};

struct font_entry {		/* font entry */
  int k, c, s, d, a, l;
  char n[STRSIZE];		/* FNT_DEF command parameters		*/
  int font_space;		/* computed from FNT_DEF s parameter	*/
  float font_mag;		/* computed from FNT_DEF s and d parameters */
  int font_type;		/* FT_PK, FT_PXL, FT_LWTEX, FT_LW	*/
  int dic_pack;			/* pack psfont dictionary		*/
  char name[STRSIZE];		/* full name of font file		*/
  FILE *font_file_id;		/* file identifier (NO_FILE if none)	*/
  int magnification;		/* magnification read from PXL file	*/
  int designsize;		/* design size read from PXL file	*/
  int nfntchars;
  struct char_entry ch[NFNTCHARS]; /* character information	*/
  struct font_entry *next;
  int ncdl;			/* # of different chars actually downloaded */
};

struct openfont_list
{
  FILE *openfont_file_id;	/* file identifier                      */
  int use_count;		/* count of "opens"                     */
  int last_use;
};
